#pragma once
#include <string>
#include <vector>
#include "SessionList.h"
#include "LogFormatter.h"
#include "consts.h"
#include "LoggerSettings.h"
#include "LogFile.h"

/*
enum{
	LMT_FOR_ALL,
	LMT_FOR_SELF,
	LMT_FOR_OTHER,
} EMsgType;
*/

//*******************************************************************

typedef std::vector<std::wstring> MsgLog;

struct MessagePool
{
	MsgLog logs;
};

//*************************************************************

typedef struct tagLogMsgInfo{
	HNsmSession hSessionID;
	EMsgType nMsgType;
	CLogFormatter* plf;
} LogMsgInfo;

//*************************************************************

class CLogger
{
protected:
	const CSessionList *m_pSessions;

public:
	CLogger(const CSessionList *pSessions);
	virtual ~CLogger(void);
	CLogger& operator =(const CLogger&)
	{ _ASSERT(FALSE); }

	void Init();
	void Cleanup();

	// Cxgnh
	void OnSessionOpen(HNsmSession SessionID);
	void OnSessionClose(HNsmSession SessionID);
	void OnMemberAdd(HNsmSession hSessionID, LPCSTR lpAccount);
	void OnMemberRemove(HNsmSession hSessionID, LPCSTR lpAccount);
	void OnMessage(HNsmSession hSessionID, PMessageInfo pMsgInfo);
	void OnSessionConnected(HNsmSession SessionID);
	void OnFileSessionStatusChange(HNsmFileSession hFSession, FileSessionStatus nStatus);

protected:
// virtual
	// ZbV쐬
	virtual void SessionOpen(HNsmSession SessionID);
	// ZbVj
	virtual void SessionClose(HNsmSession SessionID);
	// oo^
	virtual void MemberAdd(HNsmSession hSessionID, LPCSTR lpAccount);
	// o폜
	virtual void MemberRemove(HNsmSession hSessionID, LPCSTR lpAccount);


	virtual void DoLogEach(LPCTSTR lpAccount, LogMsgInfo* plmi);

// non virtual
	// ZbVJnO
	void LogSessionOpen(HNsmSession hSession, LPCSTR lpLogAcc);
	// ZbVIO
	void LogSessionClose(HNsmSession hSession, LPCSTR lpLogAcc);
	// oQO
	void LogMemberAdd(HNsmSession hSession, LPCSTR lpFrom);
	// oގO
	void LogMemberRemove(HNsmSession hSession, LPCSTR lpFrom);
	// ʏ탁bZ[W
	void LogMessage(HNsmSession hSession, PMessageInfo pMsgInfo);
	// t@C]O
	void LogFileSessionStatusChange(HNsmFileSession hFSession, FileSessionStatus nStatus);

	void DoDoLog(HNsmSession hSession, EMsgType nMsgType,
		LPCSTR lpFrom, LPCSTR lpTo, LPCSTR lpExcept,
		PMessageInfo pmi=NULL, HNsmFileSession hFSession=NULL);
	void DoLog(LogMsgInfo *plmi, LPCSTR lpTo, LPCSTR lpExcept);

// 
	void CreateDir(LPCTSTR lpLogFile) const;

	bool IsLogOnce() const
	{
		return LOGGER_SETTING.IsLogggingOnce();
	}
	// G[o
	void ErrorMsg(LPCTSTR lpErrMsg) const;
};
