#include "StdAfx.h"
#include ".\logfile.h"
#include "consts.h"
#include "cs_conv.h"

CLogFile::CLogFile(void)
: m_hFile(INVALID_HANDLE_VALUE)
{
}

CLogFile::~CLogFile(void)
{
	if( m_hFile != INVALID_HANDLE_VALUE )
		Close();
}

void CLogFile::WriteUnicode(LPCWSTR lpLogText) const
{
	_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
	DWORD len;

	// filesize==0ȂBOMt
	len = ::SetFilePointer(m_hFile, 0, NULL, FILE_CURRENT);
	if( len == 0 ){
		WriteBytes("\xFF\xFE", 2);
	}

	len = wcslen(lpLogText) * 2;
	WriteBytes(lpLogText, len);
}

void CLogFile::WriteLocale(LPCWSTR lpLogText) const
{
	_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
	std::string mbsLogText;

	::UnicodeToSJIS(lpLogText, mbsLogText);
	WriteBytes(mbsLogText.c_str(), mbsLogText.length());
}

void CLogFile::WriteBytes(LPCVOID lpLogText, DWORD len) const
{
	_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
	DWORD check;
	BOOL bSuccess;

	bSuccess = WriteFile(m_hFile, lpLogText, len, &check, NULL);
	if( !bSuccess ) throw LEM_CANT_WRITE;
}

void CLogFile::Open(LPCTSTR lpLogFile)
{
	_ASSERT( m_hFile == INVALID_HANDLE_VALUE );
	m_hFile = CreateFile(
		lpLogFile, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,
		NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	);
	if( m_hFile == INVALID_HANDLE_VALUE )
		throw LEM_CANT_OPEN_FILE;
}

void CLogFile::Seek(LONG pos, DWORD from) const
{
	_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
	DWORD check;

	check = ::SetFilePointer(m_hFile, pos, NULL, from);
	if( check == INVALID_SET_FILE_POINTER ){
		check = GetLastError();
		if( check != NO_ERROR ){
			CloseHandle(m_hFile);
			throw LEM_SEEK_MISS;
		}
	}
}

DWORD CLogFile::ReadBytes(LPVOID lpBuf, DWORD toRead) const
{
	BOOL bSuccess;
	DWORD read;

	bSuccess = ::ReadFile(m_hFile, lpBuf, toRead, &read, NULL);
	if( !bSuccess ) throw LEM_CANT_READ;
	return read;
}
