#pragma once
#include "consts.h"

class CLogFile
{
private:
	HANDLE m_hFile;

public:
	CLogFile(void);
	CLogFile(HANDLE hFile)
		: m_hFile(hFile)
	{}
	~CLogFile(void);

	DWORD ReadBytes(LPVOID lpBuf, DWORD toRead) const;
	void WriteUnicode(LPCWSTR lpLogText) const;
	void WriteLocale(LPCWSTR lpLogText) const;
	void WriteBytes(LPCVOID lpLogText, DWORD len) const;
	void Open(LPCTSTR lpLogFile);
	void Seek(LONG pos, DWORD from) const;
	void SeekEOF() const
	{ Seek(0, FILE_END); }
	void Close()
	{
		_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
		::CloseHandle(m_hFile);
		m_hFile = INVALID_HANDLE_VALUE;
	}
	void WriteLog(ECharSet cs, LPCWSTR lpLogText) const
	{
		if( cs == LCS_UNICODE ){
			WriteUnicode(lpLogText);
		}else{
			WriteLocale(lpLogText);
		}
	}
	void Attach(HANDLE hFile)
	{
		_ASSERT( m_hFile == INVALID_HANDLE_VALUE );
		m_hFile = hFile;
	}
	HANDLE Detach()
	{
		_ASSERT( m_hFile != INVALID_HANDLE_VALUE );
		HANDLE hFile = m_hFile;
		m_hFile = INVALID_HANDLE_VALUE;
		return hFile;
	}
};
