#include "StdAfx.h"
#include "logformatter.h"
#include <stdio.h>
#include "consts.h"
#include "CommonService.h"
#include "DynamicArray.h"
#include "util.h"
#include "cs_conv.h"
#include "general_strings.h"
#include "mleak.h"

// BBGGRR  RRGGBB
#define RGBSWAP(c) ( ((c) & 0x00FF00)| (((c) & 0xFF0000) >> 16) | (((c) & 0x0000FF) << 16) )

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CLogFormatter::CLogFormatter(void) 
: CPathFormatter()
{
	m_pMsgInfo = NULL;
}

CLogFormatter::~CLogFormatter(void)
{
}

//*******************************************************************
// 
//*******************************************************************
// tH[}bgɕKvȏ擾
//  hSessionID: ̎擾ZbV
//  lpFrom: bZ[WM҃AJEg
//  pMsgInfo: bZ[W
void CLogFormatter::Create(const CSessionInfo *si, PMessageInfo pMsgInfo, HNsmFileSession hFileSession)
{
	CPathFormatter::Create(si);
	m_psi = si;
	m_pMsgInfo = pMsgInfo;
	m_hFSession = hFileSession;

	LoadSenderName(m_pMsgInfo->lpFrom);
}

void CLogFormatter::Create(const CSessionInfo *si, LPCSTR lpFrom, HNsmFileSession hFileSession)
{
	CPathFormatter::Create(si);
	m_psi = si;
	m_hFSession = hFileSession;

	LoadSenderName(lpFrom);
}

void CLogFormatter::LoadSenderName(LPCSTR lpFromAccount)
{
	// MҖQbg
	// M҂[Ȕꍇ
	if( IsMyAccount(lpFromAccount) )
	{
		wchar_t buf[INFOBUF_LEN];

		::SJIStoUnicode(m_myacc.c_str(), m_lpFromAccount);
		NSM_SERVICE.GetUserName(m_psi->GetParentCon(), buf, sizeof(buf));
		m_lpFromName = buf;
	}
	else
	// M҂̃ȍꍇ
	{
		::SJIStoUnicode(lpFromAccount, m_lpFromAccount);
		LPCWSTR name = m_psi->GetMemberName(lpFromAccount);
		m_lpFromName = (name != NULL) ? name: NULL_STRINGW;
	}
}

//*******************************************************************
// 
//*******************************************************************
// ObZ[W𐶐
// lpFormat̕ϐlWĴoutɊi[
void CLogFormatter::GetLogText(std::wstring &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const
{
	std::wstring wFormat;
	std::string buf;

	// PathFormatterœWJ
	CPathFormatter::FormatStr(buf, lpTargetAccount, lpFormat);

	// Unicode֕ϊ
	::SJIStoUnicode(buf.c_str(), wFormat);

	// LogFormatterœWJ
	CLogFormatter::FormatStr(out, wFormat.c_str());
}

// lpFormat̕ϐlWĴoutɊi[
void CLogFormatter::FormatStr(std::wstring &out, LPCWSTR lpFormat) const
{
	LPWSTR fstart, fend, fprev;
	wchar_t wbuf[INFOBUF_LEN];
	const TTextAttributeInfo* ptai;

	// tH[}bgRs[
	const int formatBufferSize = wcslen(lpFormat)+1;
	DynamicArray<wchar_t> format(formatBufferSize);
	wcscpy_s(format, formatBufferSize, lpFormat);

	fprev = format;
	ptai = (m_pMsgInfo != NULL) ? m_pMsgInfo->lpTextAttribute: NULL;
	while( (fstart = wcsstr(fprev, LLF_START_DELIMITER)) != NULL
			&& (fend = wcsstr(fstart+1, LLF_END_DELIMITER)) != NULL )
	{
		*fstart = L'\0';
		*fend = L'\0';
		out += fprev;

		fstart += wcslen(LLF_START_DELIMITER);
		if( wcscmp(fstart, LLF_FONTNAME) == 0 )
		{	// tHg
			if( ptai && ptai->lpFontName ){
				out += ptai->lpFontName;
			}
		}
		else if( wcscmp(fstart, LLF_FONTSIZE) == 0 )
		{	// tHgTCY
			if( ptai && ptai->nFontSize > 0 ){
				_itow_s(ptai->nFontSize, wbuf, 10);
				out += wbuf;
			}
		}
		else if( wcscmp(fstart, LLF_FONTCOLOR) == 0 )
		{	// F
			if( ptai && ptai->nFontColor > -1 ){
				swprintf_s(wbuf, L"%06X", RGBSWAP(ptai->nFontColor));
				out += wbuf;
			}
		}
		else if( wcscmp(fstart, LLF_BACKCOLOR) == 0 )
		{	// wiF
			if( ptai && ptai->nBgColor > -1 ){
				swprintf_s(wbuf, L"%06X", RGBSWAP(ptai->nBgColor));
				out += wbuf;
			}
		}
		else if( wcscmp(fstart, LLF_STYLE)== 0  )
		{	// 
			if( !ptai || ptai->nStyles == 0 )
			{
				out += LFSS_NONE;
			}
			else
			{
				if( ptai->nStyles & NMFS_BOLD ) out += LFSS_BOLD;
				if( ptai->nStyles & NMFS_ITALIC ) out += LFSS_ITALIC;
				if( ptai->nStyles & NMFS_UNDERLINE ) out += LFSS_UNDERLINE;
				if( ptai->nStyles & NMFS_STRIKEOUT ) out += LFSS_STRIKEOUT;
			}
		}
		else if( wcscmp(fstart, LLF_FROMACCOUNT) == 0 )
		{	// M҃AJEg
			out += m_lpFromAccount;
		}
		else if( wcscmp(fstart, LLF_FROMNAME) == 0 )
		{	// MҖ
			if( m_bEscapeHtml ){
				std::wstring escaped;
				EscapeForHTML(escaped, m_lpFromName.c_str());
				out += escaped;
			}else{
				out += m_lpFromName;
			}
		}
		else if( wcscmp(fstart, LLF_MESSAGE) == 0 )
		{	// bZ[W
			if( m_pMsgInfo && m_pMsgInfo->lpBody != NULL ){
			if( m_bEscapeHtml ){
					std::wstring escaped, anchored;
					EscapeForHTML(escaped, m_pMsgInfo->lpBody);
					LinkURL(anchored, escaped.c_str());
					out += anchored;
				}else{
					out += m_pMsgInfo->lpBody;
				}
			}
		}
		else if( wcscmp(fstart, LLF_CSS) == 0 )
		{	// X^CV[g`
			if( ptai ){
				FormatStyleStr(out, ptai);
			}
		}
		else if( wcscmp(fstart, LLF_FILENAME) == 0 )
		{	// t@C
			if( m_hFSession != NULL ){
				std::string buf;
				std::wstring file;
				NSM_SERVICE.GetFileName(m_hFSession, buf);
				::SJIStoUnicode(buf.c_str(), file);
				out += file;
			}
		}
		else if( wcscmp(fstart, LLF_FILESIZE) == 0 )
		{	// t@CTCY
			if( m_hFSession != NULL ){
				int len, off;
				_itow_s(NSM_SERVICE.GetFileSize(m_hFSession), wbuf, 10);
				len = wcslen(wbuf);

				off = ((len-1) % 3) + 1;
				out.append(wbuf, off);
				while( len > off ){
					out += L',';
					out.append(wbuf + off, 3);
					off += 3;
				}
			}
		}
		else if( wcscmp(fstart, LLF_MEMBERLIST) == 0 )
		{	// Q҃Xg
			CSessionInfo::member_iterator i;

			for( i = m_psi->GetMembersBegin(); i != m_psi->GetMembersEnd(); i++ ){
				_snwprintf_s(wbuf, sizeof(wbuf)/sizeof(wchar_t), LLF_ML_FORMAT, i->second.c_str(), i->first.c_str());
				if( i != m_psi->GetMembersBegin() ) out += L", ";
				out += wbuf;
			}
		}
		else
		{
			out += LLF_START_DELIMITER;
			out += fstart;
			out += LLF_END_DELIMITER;
		}
		
		fprev = fend + wcslen(LLF_END_DELIMITER);
	}
	out += fprev;
}

// CSS`̕X^C𐶐
void CLogFormatter::FormatStyleStr(std::wstring &out, const TTextAttributeInfo* tai) const
{
	wchar_t wbuf[BUF_SIZE+1];

	wbuf[BUF_SIZE] = L'\0';

	// tHgt@~
	if( (tai->lpFontName != NULL) && (tai->lpFontName[0] != '\0') ){
		_snwprintf_s(wbuf, BUF_SIZE, L"font-family: '%s'; ", tai->lpFontName);
		out += wbuf;
	}
	// tHgTCY
	if( tai->nFontSize > -1 ){
		_snwprintf_s(wbuf, BUF_SIZE, L"font-size: %dpt; ", tai->nFontSize);
		out += wbuf;
	}
	// F
	if( tai->nFontColor > -1 ){
		_snwprintf_s(wbuf, BUF_SIZE, L"color: #%06X; ", RGBSWAP(tai->nFontColor));
		out += wbuf;
	}
	// wiF
	if( tai->nBgColor > -1 ){
		_snwprintf_s(wbuf, BUF_SIZE, L"background-color: #%06X; ", RGBSWAP(tai->nBgColor));
		out += wbuf;
	}

	// 
	if( tai->nStyles & LFS_BOLD ){
		out += L"font-weight: bold; ";
	}
	// Α
	if( tai->nStyles & LFS_ITALIC ){
		out += L"font-style: italic; ";
	}
	// 
	if( tai->nStyles & LFS_UNDERLINE ){
		out += L"text-decoration: underline; ";
	}
	// 
	if( tai->nStyles & LFS_STRIKEOUT ){
		out += L"text-decoration: line-through; ";
	}
}
