#pragma once
#include "pathformatter.h"
#include "SessionInfo.h"

class CLogFormatter: public CPathFormatter
{
public:
	// RXgN^EfXgN^
	CLogFormatter(void);
	~CLogFormatter(void);

	virtual void GetLogText(std::wstring &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const;

	// I[o[horI[o[Ch
	void Create(const CSessionInfo *si, PMessageInfo pMsgInfo, HNsmFileSession hFileSession=NULL);
	void Create(const CSessionInfo *si, LPCSTR lpFrom, HNsmFileSession hFileSession=0);
	void FormatStr(std::wstring &out, LPCWSTR lpFormat) const;
	void EnableEscapeHtml(bool enable)
	{ m_bEscapeHtml = enable; }

private:
	PMessageInfo m_pMsgInfo;		// bZ[W
	std::wstring m_lpFromAccount;		// bZ[WM҃AJEg
	std::wstring m_lpFromName;			// bZ[WMҖO
	HNsmFileSession m_hFSession;
	bool m_bEscapeHtml;

protected:
	const CSessionInfo *m_psi;

protected:
	LPCSTR GetFromAccount() const
	{
		return m_pMsgInfo->lpFrom;
	}
	bool IsMyAccount(LPCSTR lpAccount) const
	{
		return (lpAccount == NULL) || (lpAccount[0] == '\0')
			|| (strcmp(lpAccount, m_myacc.c_str()) == 0);
	}
	// LLF_HTMLp̃X^C
	void FormatStyleStr(std::wstring &out, const TTextAttributeInfo* tai) const;
	void LoadSenderName(LPCSTR lpFromAccount);
};
