#pragma once
#pragma warning( disable: 4702 )
	#include <map>
#pragma warning( default: 4702 )
#include "SessionList.h"
#include "consts.h"
#include "CLogger.h"
#include "LoggerSettings.h"
//*************************************************************

//*************************************************************

class CLoggerMain
{
private:
	CSessionList m_sessions;
	CLogger *m_pLogger;
	CRITICAL_SECTION m_lock;

public:
	CLoggerMain(void);
	~CLoggerMain(void);

	void OnInitialize();
	void OnMemberAdd(HNsmSession hSessionID, LPCSTR lpAccount);
	void OnMemberRemove(HNsmSession hSessionID, LPCSTR lpAccount);
	void OnSendMessage(HNsmSession SessionID, PMessageInfo pMsgInfo);
	void OnReceiveMessage(HNsmSession SessionID, PMessageInfo pMsgInfo);
	void OnSessionOpen(HNsmSession SessionID);
	void OnSessionClose(HNsmSession SessionID);
	void OnSessionInfoChange(HNsmSession hSession, PNsmSessionInfo pnsi);
	void OnSessionMembersInfoChange(HNsmSession hSession, PNsmMemberInfo pnmi);
//	void OnFileSessionOpen(HNsmFileSession hFSession);
//	void OnFileSessionClose(HNsmFileSession hFSession);
	void OnFileSessionInfoChange(HNsmFileSession hFSession, PNsmFileSessionInfo pfsi);
	void DoShowOptionDialog(HWND hWnd);
	void DoDebugLog(LPCTSTR str);
	void GetLogPath(HNsmConnection hConnection, LPCSTR targetAcc, std::string &path);

private:
	void RegistNewSession(HNsmSession hSession);
	void UnRegistSession(HNsmSession hSession);
	void UpdateLogger();

	void Lock()
	{
		EnterCriticalSection(&m_lock);
	}
	void Unlock()
	{
		LeaveCriticalSection(&m_lock);;
	}
};
