#include "StdAfx.h"
#include ".\msgpool.h"

CMsgPool::CMsgPool(void)
{
}

CMsgPool::~CMsgPool(void)
{
}

bool CMsgPool::RegistSessionPool(HNsmSession SessionID, LPCSTR lpFile)
{
	FileMsgPoolList::const_iterator i;
	CFileMsgPool *pfmp;

	i = m_msgPools.find(lpFile);
	if( i == m_msgPools.end() ){
		try
		{
			pfmp = new CFileMsgPool(lpFile);
		}
		catch(LPCSTR lpErrMsg)
		{
			ErrorMsg(lpErrMsg);
			return false;
		}
		i = m_msgPools.insert(std::make_pair(lpFile, pfmp)).first;
	}
	i->second->Regist(SessionID);
	return true;
}

void CMsgPool::UnRegistSessionPool(HNsmSession SessionID, LPCSTR lpFile)
{
	_ASSERT(SessionRegisterd(lpFile, SessionID));
	FileMsgPoolList::iterator i;

	i = m_msgPools.find(lpFile);
	if( i == m_msgPools.end() ) return;
	i->second->UnRegist();

	if( ! i->second->IsRegisterd() ){
		delete i->second;
		m_msgPools.erase(i);
	}
}

void CMsgPool::UnregistAll()
{
	FileMsgPoolList::iterator pool;

	for( pool = m_msgPools.begin(); pool != m_msgPools.end(); pool++ )
		delete pool->second;
}

//------------
void CMsgPool::RegistLogger()
{
	m_refCount++;
}

void CMsgPool::UnregistLogger()
{
	m_refCount--;

	if( m_refCount == 0 ){
		UnregistAll();
	}
}

//------------
void CMsgPool::RegistSession(HNsmSession hSes)
{
	_ASSERT( hSes != NULL );
	_ASSERT( ! IsSessionRegistered(hSes) );

	m_filemap[hSes] = new AccToFileMap;
}

void CMsgPool::UnregistSession(HNsmSession hSes)
{
	_ASSERT( hSes != NULL );
	_ASSERT( IsSessionRegistered(hSes) );

	AccToFileMap* pafm;
	AccToFileMap::iterator map;

	pafm = m_filemap[hSes];
	for( map = pafm->begin(); map != pafm->end(); map++ ){
		UnRegistSessionPool(hSes, map->second.c_str());
	}
	delete pafm;
	m_filemap.erase(hSes);
}

//------------
bool CMsgPool::RegistSessionMember(HNsmSession hSes, LPCSTR acc, LPCSTR filename)
{
	_ASSERT( ! IsSessionMemberRegistered(SessionID, lpAccount) );
	_ASSERT( ! IsSessionMemberRegistered(SessionID, lpAccount) );

	FileMsgPoolList::const_iterator i;
	CFileMsgPool *pfmp;

	i = m_msgPools.find(lpFile);
	if( i == m_msgPools.end() ){
		try
		{
			pfmp = new CFileMsgPool(lpFile);
		}
		catch(LPCSTR lpErrMsg)
		{
			ErrorMsg(lpErrMsg);
			return false;
		}
		i = m_msgPools.insert(std::make_pair(filename, pfmp)).first;
	}
	i->second->Regist(SessionID);

	return true;
}

bool CMsgPool::UnregistSessionMember(HNsmSession hSes, LPCSTR acc)
{
	_ASSERT( IsSessionMemberRegistered(SessionID, lpAccount) );

	std::string file;

	GetLogFileName(SessionID, lpAccount, file);
	UnRegistSessionPool(SessionID, file.c_str());
	_ASSERT(SessionRegisterd(lpFile, SessionID));
	FileMsgPoolList::iterator i;

	i = m_msgPools.find(lpFile);
	if( i == m_msgPools.end() ) return;
	i->second->UnRegist();

	if( ! i->second->IsRegisterd() ){
		delete i->second;
		m_msgPools.erase(i);
	}
	m_filemap[SessionID]->erase(lpAccount);
}

LPCSTR CMsgPool::GetLogFileName(HNsmSession hSes, LPCSTR acc)
{
}

//------------
void CMsgPool::PoolMsg(const std::string &filename, HNsmSession hSes, const std::wstring &text)
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}

void CMsgPool::()
{
}
