#pragma once
#include <map>
#include <vector>
#include <string>
#include "FileMsgPool.h"
#include "clogger.h"
#include "../nsmsgs/debug.h"

//*******************************************************************

/*
	CMessageLogger
		FileMsgPoolList = map(filename => CFileMsgPool*)
			CFileMsgPool
				FileMsgPool = map(session => MessagePool*)
					MessagePool

	FileMsgPoolList{
		file => CFileMsgPool{
			Offset
			RegistCount
			FileMsgPool{
				Session => MessagePool
			}
		}
	}

	SAtoFileMap = map(session => AcctoFileMap*)
		AccToFileMap = map(acc => filename)

*/

//*******************************************************************

class CMsgPool
{
	typedef std::map<std::string, CFileMsgPool*> FileMsgPoolList;

	typedef std::map<std::string , std::string> AccToFileMap;
	typedef std::map<HNsmSession, AccToFileMap*> SAtoFileMap;

// vpeB
protected:
	static int m_refCount;
	static FileMsgPoolList m_msgPools;
	static SAtoFileMap m_filemap;

public:
	CMsgPool(void);
	~CMsgPool(void);

	bool RegistSessionPool(HNsmSession SessionID, LPCSTR lpFile);
	void UnRegistSessionPool(HNsmSession SessionID, LPCSTR lpFile);


DEBUG_CODE(
public:
	bool IsSessionRegistered(HNsmSession s) const
	{
		return m_filemap.find(s) != m_filemap.end();
	}
	bool IsSessionMemberRegistered(HNsmSession s, LPCSTR acc) const
	{
		if( IsSessionRegistered(s) ){
			return IsSessionMemberRegistered(m_filemap[s], acc);
		}
		return false;
	}
	bool IsSessionMemberRegistered(const AccToFileMap* map, LPCSTR acc) const
	{
		return map->find(acc) != map->end();
	}

	bool IsFileRegistered(LPCSTR fname) const
	{
		return m_msgPools.find(fname) != m_msgPools.end();
	}
	bool IsMsgPoolRegistered(LPCSTR fname, HNsmSession s) const
	{
		if( IsFileRegistered(fname) ){
			return IsMsgPoolRegistered(m_msgPools[fname], s);
		}
		return false;
	}
	bool IsMsgPoolRegistered(const CFileMsgPool* pool, HNsmSession s) const
	{
		return pool->Exists(s);
	}

/*
	bool SessionRegisterd(HNsmSession s, LPCSTR a) const
	{
		std::string file;
		GetLogFileName(s, a, file);
		return SessionRegisterd(file.c_str(), s);
	}
	bool SessionRegisterd(LPCSTR lpFile, HNsmSession s) const
	{
		return MemberRegisterd(lpFile) && m_msgPools.find(lpFile)->second->Exists(s);
	}
	bool MemberRegisterd(LPCSTR lpFile) const
	{
		return m_msgPools.find(lpFile) != m_msgPools.end();
	}
*/
)
};
