#include "StdAfx.h"
#include "optiondlg.h"
#include <Shlobj.h>
#include <Shtypes.h>
#include "NsmPlugin.h"

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
COptionDlg::COptionDlg()
: CDlg(IDD_OPTDLG)
{
}

COptionDlg::~COptionDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
// ݒ_CAÕ_CAOvV[W
BOOL COptionDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM /*lParam*/)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		// Qƃ{^
		case IDC_REF:
			BrowsDir();
			break;

		// JX^ݒ{^
		case IDC_CUSTOM_BTN:
			ShowCustomDlg();
			break;

		// WI{^
		case IDC_NISE:
		case IDC_MSN:
		case IDC_TEXT:
		case IDC_TEXTPLUS:
		case IDC_HTML:
		case IDC_CUSTOM:
			EnableTextOptions(!GetCheck(IDC_MSN));
			SetEnable(IDC_CUSTOM_BTN, GetCheck(IDC_CUSTOM));
			break;

		// `FbN{bNX
		case IDC_SESSION:
			SetEnable(IDC_SAVE_PER_MSG, GetCheck(IDC_SESSION));
			break;

		default:
			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

// ݒ_CAORg[
BOOL COptionDlg::InitDlgCtrl()
{
	HWND hItemWnd;
	int cid, sid;

	// G[ɒʒm
	SetCheck(IDC_NOTIFYERROR, LOGGER_SETTING.IsNotifyError());

	// Zbg
	SetCheck(IDC_UNICODE, (LOGGER_SETTING.GetCharSet() == LCS_UNICODE));
	SetCheck(IDC_SJIS, (LOGGER_SETTING.GetCharSet() != LCS_UNICODE));

	// HTMLGXP[vs
	SetCheck(IDC_ESCAPEHTML, LOGGER_SETTING.IsEnableEscapeHtml());

	// ZbVǗ
	SetCheck(IDC_SESSION, LOGGER_SETTING.IsSeparateSession());
	SetCheck(IDC_SAVE_PER_MSG, LOGGER_SETTING.IsSavePerMessage());

	// OL^`
	switch( LOGGER_SETTING.GetFormatType() ){
	case LFT_NISE:	SetCheck(IDC_NISE, true); break;
	case LFT_MSN:	SetCheck(IDC_MSN, true); break;
	case LFT_TEXT:	SetCheck(IDC_TEXT, true); break;
	case LFT_TEXTPLUS:	SetCheck(IDC_TEXTPLUS, true); break;
	case LFT_HTML:	SetCheck(IDC_HTML, true); break;
	case LFT_CUSTOM:	SetCheck(IDC_CUSTOM, true); break;
	}

	// GfBbg{bNX
	hItemWnd = GetDlgItem(IDC_PATH);
	::SetWindowText(hItemWnd, LOGGER_SETTING.GetBaseDir());

	hItemWnd = GetDlgItem(IDC_PATHFORMAT);
	::SetWindowText(hItemWnd, LOGGER_SETTING.GetPathFormat());

	// JX^tH[}bg
	for( int i = 0; i < LMT_NUM; i++ )
		m_logFormat[i] = LOGGER_SETTING.GetCustomFormat((EMsgType)i);

	EnableTextOptions(!GetCheck(IDC_MSN));
	SetEnable(IDC_CUSTOM_BTN, GetCheck(IDC_CUSTOM));

	m_tip.Create(m_hInstance, m_hDlgWnd);

	cid = IDC_UNICODE;
	sid =IDS_UNICODE;
	for( ; cid <= IDC_PATHFORMAT; cid++, sid++ ){
		m_tip.AddToolToToolTip(m_hInstance, m_hDlgWnd, GetDlgItem(cid), sid);
	}
	m_tip.Begin();

	return TRUE;
}

// ݒ_CAO̒lOptionSettingsɐݒ
BOOL COptionDlg::GetDlgCtrlValue()
{
	std::string str;

	// G[ɒʒm
	LOGGER_SETTING.EnableNotifyError(GetCheck(IDC_NOTIFYERROR));

	// Zbg
	LOGGER_SETTING.SetCharSet(GetCheck(IDC_UNICODE) ? LCS_UNICODE: LCS_LOCALE);

	// HTMLGXP[vs
	LOGGER_SETTING.EnableEscapeHtml(GetCheck(IDC_ESCAPEHTML));

	// ZbVǗ
	LOGGER_SETTING.EnableSeparateSession(GetCheck(IDC_SESSION));
	LOGGER_SETTING.EnableSavePerMessage(GetCheck(IDC_SAVE_PER_MSG));

	// OL^`
	if( GetCheck(IDC_NISE) ) LOGGER_SETTING.SetFormatType(LFT_NISE);
	if( GetCheck(IDC_MSN) ) LOGGER_SETTING.SetFormatType(LFT_MSN);
	if( GetCheck(IDC_TEXT) ) LOGGER_SETTING.SetFormatType(LFT_TEXT);
	if( GetCheck(IDC_TEXTPLUS) ) LOGGER_SETTING.SetFormatType(LFT_TEXTPLUS);
	if( GetCheck(IDC_HTML) ) LOGGER_SETTING.SetFormatType(LFT_HTML);
	if( GetCheck(IDC_CUSTOM) ) LOGGER_SETTING.SetFormatType(LFT_CUSTOM);

	// GfBbg{bNX
	GetItemText(IDC_PATH, str);
	LOGGER_SETTING.SetBaseDir(str.c_str());

	GetItemText(IDC_PATHFORMAT, str);
	LOGGER_SETTING.SetPathFormat(str.c_str());

	// JX^tH[}bg
	for( int i = 0; i < LMT_NUM; i++ )
		LOGGER_SETTING.SetCustomFormat((EMsgType)i, m_logFormat[i].c_str());

	return TRUE;
}

//*******************************************************************
// _CAO
//*******************************************************************
// tH_Qƃ_CAOI[v
void COptionDlg::BrowsDir()
{
	HWND hItemWnd;
	TCHAR lpEdittingPath[MAX_PATH];
	TCHAR lpSelectedPath[MAX_PATH];
	BROWSEINFO bi;
	LPITEMIDLIST lpSelectedID;
	LPMALLOC lpSHMalloc;

	// IvV_CAÕGfBbg{bNXpX擾
	hItemWnd = GetDlgItem(IDC_PATH);
	::GetWindowText(hItemWnd, lpEdittingPath, MAX_PATH);

	if(FAILED(::SHGetMalloc(&lpSHMalloc)))
        return;

	// tH_I_CAOJ
	bi.hwndOwner = m_hDlgWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = NULL;
	bi.lpszTitle = _T("OۑtH_I");
	bi.ulFlags = (BIF_NEWDIALOGSTYLE);
	bi.lpfn = BrowsDlgProc;
	bi.lParam = (LPARAM)lpEdittingPath;
	bi.iImage = 0;

	lpSelectedID = ::SHBrowseForFolder(&bi);

	if( lpSelectedID ){
        ::SHGetPathFromIDList(lpSelectedID, lpSelectedPath);
		lpSHMalloc->Free(lpSelectedID);

		// IvV_CAÕGfBbg{bNXփpXݒ
		::SetWindowText(hItemWnd, lpSelectedPath);
	}
}

// JX^ݒ_CAOI[v
void COptionDlg::ShowCustomDlg()
{
	// OtH[}bg
	for( int i = 0; i < LMT_NUM; i++ )
		m_customDlg.SetLogFormat(i, m_logFormat[i].c_str());

	// I[v
	if( m_customDlg.DoModal(CNsmPlugin::GetModuleInstance(), m_hDlgWnd) == IDOK ){
		// OtH[}bgǂݎ
		for( int i = 0; i < LMT_NUM; i++ )
			m_logFormat[i] = m_customDlg.GetLogFormat(i);
	}
}

//*******************************************************************
// _CAOvV[W
//*******************************************************************
// tH_I_CAÕ_CAOvV[W
int CALLBACK COptionDlg::BrowsDlgProc(HWND hWnd, UINT uMsg, LPARAM /*lParam*/, LPARAM lpData)
{
    switch(uMsg){
    case BFFM_INITIALIZED:
        if((TCHAR*)lpData != NULL)
		{
			::SendMessage(hWnd, BFFM_SETSELECTION, (WPARAM)TRUE, (LPARAM)lpData);
		}
        break;
    }

    return 0;
}
