#include "StdAfx.h"
#include <stdio.h>
#include "pathformatter.h"
#include "DynamicArray.h"
#include "commonservice.h"
#include "consts.h"

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CPathFormatter::CPathFormatter(void)
{
}

CPathFormatter::~CPathFormatter(void)
{
}

//*******************************************************************
// 
//*******************************************************************
void CPathFormatter::Create(const CSessionInfo *si)
{
	// Qbg
	::GetLocalTime(&m_time);

	m_proto = si->GetProtocol();
	m_myacc = si->GetMyAccount();
}

void CPathFormatter::Create(HNsmConnection hConnectionID)
{
	TCHAR buf[INFOBUF_LEN];

	// Qbg
	::GetLocalTime(&m_time);

	// vgRQbg
	NSM_SERVICE.GetProtocol(hConnectionID, buf, sizeof(buf));
	m_proto = buf;

	// [UAJEgQbg
	NSM_SERVICE.GetUserAccount(hConnectionID, buf, sizeof(buf));
	m_myacc = buf;
}

// tH[}bgɃOt@CpX쐬
void CPathFormatter::GetLogPath(
			std::string &out, LPCTSTR lpBaseDir, LPCTSTR lpTargetAccount,
			LPCTSTR lpFormat
) const
{
	out = lpBaseDir;
	FormatStr(out, lpTargetAccount, lpFormat);
}

// lpFormat̕ϐlWĴoutɊi[
void CPathFormatter::FormatStr(std::string &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const
{
	LPTSTR fstart, fend, fprev;
	TCHAR intbuf[ITOT_BUF_LEN];

	// tH[}bgRs[
	const int formatBufferSize = strlen(lpFormat)+1;
	DynamicArray<char> format(formatBufferSize);
	strcpy_s(format, formatBufferSize, lpFormat);

	// WJ
	fprev = format;
	while( (fstart = _tcsstr(fprev, LPF_START_DELIMITER)) != NULL
			&& (fend = _tcsstr(fstart+1, LPF_END_DELIMITER)) != NULL )
	{
/*
	** format **
	abcdefghijkl<!--control-->mnopqrstu
	|           |          |
	fprev       fstart     fend

	** lpBuf **
	***********************************
*/
		*fstart = _T('\0');
		*fend = _T('\0');
		out += fprev;

		fstart += _tcslen(LPF_START_DELIMITER);

/*
	** format **
	abcdefghijkl(\0)!--control(\0)->mnopqrstu
	|                  |       |
	fprev              fstart  fend

	** lpBuf **
	abcdefghijkl(\0)*************************
*/
		if( lstrcmp(fstart, LPF_DATE) == 0 )
		{	// t
			_snprintf_s(intbuf, sizeof(intbuf), "%04d/%02d/%02d",
				m_time.wYear, m_time.wMonth, m_time.wDay);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_TIME) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%02d:%02d:%02d",
				m_time.wHour, m_time.wMinute, m_time.wSecond);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_YEAR) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%04d", m_time.wYear);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_MONTH) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%02d", m_time.wMonth);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_DAY) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%02d", m_time.wDay);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_HOUR) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%02d", m_time.wHour);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_MINUTE) == 0 )
		{	// 
			_snprintf_s(intbuf, sizeof(intbuf), "%02d", m_time.wMinute);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_SECOND) == 0 )
		{	// b
			_snprintf_s(intbuf, sizeof(intbuf), "%02d", m_time.wSecond);
			out += intbuf;
		}
		else if( lstrcmp(fstart, LPF_PROTOCOL) == 0 )
		{	// vgR
			out += m_proto;
		}
		else if( lstrcmp(fstart, LPF_MYACCOUNT) == 0 )
		{	// ̃AJEg
			out += m_myacc;
		}
		else if( lstrcmp(fstart, LPF_TARGETACCOUNT) == 0 )
		{	// Ώۂ̃AJEg
			if( lpTargetAccount != NULL )
				out += lpTargetAccount;
		}
		else
		{
			out += LPF_START_DELIMITER;
			out += fstart;
			out += LPF_END_DELIMITER;
		}
		
		fprev = fend + _tcslen(LPF_END_DELIMITER);
	}
	out += fprev;
}
