#pragma once
#pragma warning( disable: 4702 )
	#include <map>
#pragma warning( default: 4702 )
#include "SessionInfo.h"

class CSessionList
{
private:
	typedef std::map<HNsmSession, CSessionInfo*> SessionList;

public:
	typedef SessionList::const_iterator session_iterator;

private:
	SessionList m_sessions;

public:
	CSessionList(void)
	{
	}
	~CSessionList(void)
	{
		SessionList::iterator i;

		for(i = m_sessions.begin(); i != m_sessions.end(); i++){
			delete i->second;
		}
	}

	const SessionList::mapped_type operator[](HNsmSession hSession) const
	{
		_ASSERT(SessionRegisterd(hSession));
		return m_sessions.find(hSession)->second;
	}
	SessionList::mapped_type operator[](HNsmSession hSession)
	{
		_ASSERT(SessionRegisterd(hSession));
		return m_sessions[hSession];
	}
	void CreateSessionInfoEntry(HNsmSession hSession)
	{
		_ASSERT( ! SessionRegisterd(hSession) );
		m_sessions.insert(std::make_pair(hSession, new CSessionInfo));
	}
	void DeleteSessionInfoEntry(HNsmSession hSession)
	{
		_ASSERT(SessionRegisterd(hSession));
		delete m_sessions[hSession];
		m_sessions.erase(hSession);
	}
	session_iterator begin() const
	{
		return m_sessions.begin();
	}
	session_iterator end() const
	{
		return m_sessions.end();
	}
	
private:
	bool SessionRegisterd(HNsmSession hSession) const
	{
		return m_sessions.find(hSession) != m_sessions.end();
	}

};
