#pragma once
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )
#include <utility>
#include "tstring.h"
#include "StringList.h"

class SmartLogFinder
{
private:
	const LPCSTR m_base;
	const LPCSTR m_proto;
	const LPCSTR m_myacc;
	const LPCSTR m_tgacc;

public:
	SmartLogFinder(LPCSTR base, LPCSTR proto, LPCSTR myacc, LPCSTR tgacc);
	~SmartLogFinder(void){};

	void GetLatestLog(std::string &path, std::string &menu, const std::string &format);

private:
	SmartLogFinder& operator =(const SmartLogFinder&)
	{ _ASSERT(FALSE); }

	bool Dir(std::string &file, const std::string path, LPCSTR dir);
	bool FormatMatch(LPCSTR format, LPCSTR str);
	bool ReplaceTag(std::string &out, LPCSTR in);
	void MakeMenuString(std::string* pMenu, LPCSTR format, LPCSTR str);
	int GetNumber(LPCSTR str, int num)
	{
		int ret = 0;
		for( int i = 0; i < num; ++i ){
			const char &c = *(str + i);
			if( c < '0' || '9' < c )
				return -1;
			ret = ret * 10 + (c - '0');
		}
		return ret;
	}

private:
	static bool StringCompare(const tstring& a, const tstring& b)
	{
		return a > b;
	}
};
