#include "StdAfx.h"
#include ".\xmllogformatter.h"
#include "DynamicArray.h"
#include "CommonService.h"
#include "util.h"
#include "consts.h"

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CXMLLogFormatter::CXMLLogFormatter(void)
{
}

CXMLLogFormatter::~CXMLLogFormatter(void)
{
}

//*******************************************************************
// 
//*******************************************************************
// tH[}bgɕKvȏ擾
//  hSessionID: ̎擾ZbV
//  lpFrom: bZ[WM҃AJEg
//  pMsgInfo: bZ[W
void CXMLLogFormatter::Create(const CSessionInfo *si, PMessageInfo pMsgInfo, HNsmFileSession hFileSession)
{
	wchar_t buf[INFOBUF_LEN];

	CLogFormatter::Create(si, pMsgInfo, hFileSession);

	NSM_SERVICE.GetUserName(si->GetParentCon(), buf, sizeof(buf));
	m_myName = buf;

}

void CXMLLogFormatter::Create(const CSessionInfo *si, LPCSTR lpFrom, HNsmFileSession hFileSession)
{
	wchar_t buf[INFOBUF_LEN];

	CLogFormatter::Create(si, lpFrom, hFileSession);

	NSM_SERVICE.GetUserName(si->GetParentCon(), buf, sizeof(buf));
	m_myName = buf;

}

//*******************************************************************
// 
//*******************************************************************
// ObZ[W𐶐
// lpFormat̕ϐlWĴoutɊi[
void CXMLLogFormatter::GetLogText(std::wstring &out, LPCTSTR lpTargetAccount, LPCTSTR lpFormat) const
{
	std::wstring wFormat;

	// LogFormatterœWJ
	CLogFormatter::GetLogText(wFormat, lpTargetAccount, lpFormat);

	CXMLLogFormatter::FormatStr(out, wFormat.c_str());
}

// lpFormat̕ϐlWĴoutɊi[
void CXMLLogFormatter::FormatStr(std::wstring &out, LPCWSTR lpFormat) const
{
	LPWSTR fstart, fend, fprev;
	wchar_t wbuf[INFOBUF_LEN];

	// tH[}bgRs[
	const int formatBufferSize = wcslen(lpFormat)+1;
	DynamicArray<wchar_t> format(formatBufferSize );
	wcscpy_s(format, formatBufferSize , lpFormat);

	fprev = format;
	while( (fstart = wcsstr(fprev, LLF_START_DELIMITER)) != NULL
			&& (fend = wcsstr(fstart+1, LLF_END_DELIMITER)) != NULL )
	{
		*fstart = L'\0';
		*fend = L'\0';
		out += fprev;

		fstart += wcslen(LLF_START_DELIMITER);
		if( wcscmp(fstart, LXF_DATETIME) == 0 )
		{	// 
			SYSTEMTIME st;
			::GetSystemTime(&st);
			swprintf_s(wbuf, L"%04d-%02d-%02dT%02d:%02d:%02d.%03dZ",
				st.wYear, st.wMonth, st.wDay, st.wHour,
				st.wMinute, st.wSecond, st.wMilliseconds);
			out += wbuf;
		}
		else if( wcscmp(fstart, LXF_TOLIST) == 0 )
		{	// ToXg
			CSessionInfo::member_iterator i;
			std::wstring escaped;

			if( IsMyAccount(GetFromAccount()) ){
				for( i = m_psi->GetMembersBegin(); i != m_psi->GetMembersEnd(); i++ ){
					EscapeForHTML(escaped, i->second.c_str());
					_snwprintf_s(wbuf, sizeof(wbuf)/sizeof(wchar_t), LXF_USERFORMAT, i->first.c_str(), i->second.c_str());
					out += wbuf;
				}
			}else{
				_snwprintf_s(wbuf, sizeof(wbuf)/sizeof(wchar_t), LXF_USERFORMAT, m_myacc.c_str(), m_myName.c_str());
				out += wbuf;
				for( i = m_psi->GetMembersBegin(); i != m_psi->GetMembersEnd(); i++ ){
					if( i->first != GetFromAccount() ){
						EscapeForHTML(escaped, i->second.c_str());
						_snwprintf_s(wbuf, sizeof(wbuf)/sizeof(wchar_t), LXF_USERFORMAT, i->first.c_str(), i->second.c_str());
						out += wbuf;
					}
				}
			}
		}
		else if( wcscmp(fstart, LXF_RESPONCE) == 0 )
		{	// Responceǂ
		}
		else
		{
			out += LLF_START_DELIMITER;
			out += fstart;
			out += LLF_END_DELIMITER;
		}
		
		fprev = fend + wcslen(LLF_END_DELIMITER);
	}
	out += fprev;
}
