#include "StdAfx.h"
#include ".\xmlmessagelogger.h"

CXMLMessageLogger::CXMLMessageLogger(void)
{
}

CXMLMessageLogger::~CXMLMessageLogger(void)
{
}

//*******************************************************************
// 
//*******************************************************************

void CXMLMessageLogger::OnMemberSessionOpen(HNsmSession SessionID, LPCSTR lpAccount)
{
	RegistSessionPool(lpAccount, SessionID);

	CLogger::OnMemberSessionOpen(SessionID, lpAccount);
}

void CXMLMessageLogger::DoLog(LPCTSTR lpAccount, LogMsgInfo* plmi)
{
	std::string file;
	std::wstring logText;

	GetLogFileName(plmi->hSessionID, lpAccount, file);
	_ASSERT( SessionRegisterd(file, plmi->hSessionID) );

	plmi->plf->GetLogText(logText, lpAccount, LOGGER_SETTING.GetLogFormat(plmi->nMsgType));

	(*m_msgPools[file])[plmi->hSessionID]->logs.push_back(logText);
	FlushMsgPool(file, plmi->hSessionID);
}

//*******************************************************************
// 
//*******************************************************************

void CMessageLogger::FlushMsgPool(std::string &file, HNsmSession SessionID)
{
	HANDLE hFile = INVALID_HANDLE_VALUE;
	std::string path = LOGGER_SETTING.GetBaseDir() + file;
	CFileMsgPool *pfmp;
	FileMsgPool::const_iterator msgs;
	MsgLog *pml;
	MsgLog::const_iterator msg;

	CreateDir(path.c_str());
	pfmp = m_msgPools[file];

	try
	{
		hFile = OpenFile(path.c_str());
		Seek(hFile, pfmp->GetOffset(), FILE_BEGIN);
		if( LOGGER_SETTING.GetCharSet() == LCS_UNICODE ){
			for( msgs = pfmp->begin(); msgs != pfmp->end(); msgs++ ){
				pml = &(msgs->second->logs);
				for( msg = pml->begin(); msg != pml->end(); msg++ ){
					WriteUnicode(hFile, msg->c_str());
				}
			}
		}else{
			for( msgs = pfmp->begin(); msgs != pfmp->end(); msgs++ ){
				pml = &(msgs->second->logs);
				for( msg = pml->begin(); msg != pml->end(); msg++ ){
					WriteLocale(hFile, msg->c_str());
				}
			}
		}
		CloseHandle(hFile);
	}
	catch(LPCTSTR lpErrMsg)
	{
		if( hFile != INVALID_HANDLE_VALUE ) CloseHandle(hFile);
		ErrorMsg(lpErrMsg, SessionID);
	}
}
