#include "stdafx.h"
#include "etc.h"

// Logger Custom Dialog
const LPCSTR LCD_FORMAT[] = {
	LPF_DATE,
	LPF_TIME,
	LPF_YEAR,
	LPF_MONTH,
	LPF_DAY,
	LPF_HOUR,
	LPF_MINUTE,
	LPF_SECOND,
	LPF_PROTOCOL,
	LPF_MYACCOUNT,
	LPF_TARGETACCOUNT,
	LPF_FONTNAME,
	LPF_FONTSIZE,
	LPF_FONTCOLOR,
	LPF_BACKCOLOR,
	LPF_STYLE,
	LPF_FROMACCOUNT,
	LPF_FROMNAME,
	LPF_MESSAGE,
	LPF_CSS,
	LPF_FILENAME,
	LPF_FILESIZE,
	LPF_MEMBERLIST,
};

const LPCSTR LLF_PRESET[][LMT_NUM] = {
	{	// UbZW[݊
		_T(
			"[<!--Time-->] <!--FromName-->F\r\n"
			"<!--Message-->\r\n"
		),
		_T(
			"\r\n"
			"# --------------------------------------------------------------------\r\n"
			"# To: <!--MemberList-->\r\n"
			"# Date: <!--Date--> <!--Time-->\r\n"
			"# --------------------------------------------------------------------\r\n"
			"\r\n"
		),
		_T(
			"\r\n"
		),
		_T(
			"\r\n"
			"\\\\\\r\n"
			"<!--FromAccount--> ܂\r\n"
			"\\\\\\r\n"
			"\r\n"
		),
		_T(
			"\r\n"
			"\\\\\\r\n"
			"<!--FromName--> ގ܂\r\n"
			"\\\\\\r\n"
			"\r\n"
		),
		_T(
			"\r\n"
			"\\\\\\r\n"
			"t@C]F<!--FileName-->i<!--FileSize-->oCgj<!--Message-->܂B\r\n"
			"\\\\\\r\n"
			"\r\n"
		)
	},
	{	// eLXg`iʏj
		_T(
			"[<!--Date--> <!--Time-->] <!--FromName--> <<!--FromAccount-->>\r\n"
			"<!--Message-->\r\n"
		),
		_T(
			"\r\n"
			"# --------------------------------------------------------------------\r\n"
			"# Session Open at <!--Date--> <!--Time-->\r\n"
			"# Members: <!--MemberList-->\r\n"
			"# --------------------------------------\r\n"
		),
		_T(
			"# --------------------------------------\r\n"
			"# Session Close at <!--Date--> <!--Time-->\r\n"
			"# --------------------------------------------------------------------\r\n"
			"\r\n"
		),
		_T(
			"[<!--Date--> <!--Time-->] <!--FromName--> <<!--FromAccount-->> Q܂\r\n"
		),
		_T(
			"[<!--Date--> <!--Time-->] <!--FromName--> <<!--FromAccount-->> ގ܂\r\n"
		),
		_T(
			"[<!--Date--> <!--Time-->] t@C]F<!--FileName-->i<!--FileSize-->oCgj\r\n"
			"<!--Message-->\r\n"
		)
	},
	{	// eLXg`iڍׁj
		_T(
			"\r\n"
			": <!--Date--> <!--Time-->\r\n"
			"tHg: <!--FontName-->\r\n"
			"TCY: <!--FontSize-->pt\r\n"
			"F: #<!--FontColor-->\r\n"
			"wiF: #<!--BackColor-->\r\n"
			"X^C: <!--Style-->\r\n"
			"O: <!--FromName-->\r\n"
			"AJEg: <!--FromAccount-->\r\n"
			"bZ[W:\r\n"
			"<!--Message-->\r\n"
			"# --------------------------------------\r\n"
		),
		_T(
			"\r\n"
			"# --------------------------------------------------------------------\r\n"
			"# ZbVJn: <!--Date--> <!--Time-->\r\n"
			"# Qo: <!--MemberList-->\r\n"
			"# --------------------------------------\r\n"
		),
		_T(
			"# ZbVI: <!--Date--> <!--Time-->\r\n"
			"# --------------------------------------------------------------------\r\n"
			"\r\n"
		),
		_T(
			": <!--Date--> <!--Time-->\r\n"
			"O: <!--FromName-->\r\n"
			"AJEg: <!--FromAccount-->\r\n"
			"oQ܂\r\n"
			"# --------------------------------------\r\n"
		),
		_T(
			": <!--Date--> <!--Time-->\r\n"
			"O: <!--FromName-->\r\n"
			"AJEg: <!--FromAccount-->\r\n"
			"O: <!--FromName-->\r\n"
			"oގ܂\r\n"
			"# --------------------------------------\r\n"
		),
		_T(
			": <!--Date--> <!--Time-->\r\n"
			"t@C: <!--FileName-->\r\n"
			"t@CTCY: <!--FileSize-->\r\n"
			"t@C]<!--Message-->܂B\r\n"
			"# --------------------------------------\r\n"
		)
	},
	{	// HTML`
		_T(
			"<span title=\"<!--Date-->\">[<!--Time-->]</span> <span title=\"<!--FromAccount-->\"><!--FromName--></span>:<br>\r\n"
			"<font style=\"<!--CSS-->\"><!--Message--></font><br>\r\n"
		),
		_T(
			"<hr><hr>Session Open at <!--Date--> <!--Time--><br>\r\n"
			"Members: <!--MemberList--><hr>\r\n"
			"<!-- ************************************* -->\r\n"
		),
		_T(
			"<hr>Session Close at <!--Date--> <!--Time--><hr>\r\n"
		),
		_T(
			"<span title=\"<!--Date-->\">[<!--Time-->]</span> System Message:<br>\r\n"
			"<!--FromAccount--> Q܂<br>\r\n"
		),
		_T(
			"<span title=\"<!--Date-->\">[<!--Time-->]</span> System Message:<br>\r\n"
			"<!--FromName--> &lt;<!--FromAccount-->&gt; ގ܂<br>\r\n"
		),
		_T(
			"<span title=\"<!--Date-->\">[<!--Time-->]</span> System Message:<br>\r\n"
			"t@C]F<!--FileName-->i<!--FileSize-->oCgj<!--Message-->܂B<br>\r\n"
		)
	}
};

const LPCSTR LLF_XML[] = {
	_T(
		"<Message Date=\"<!--Date-->\" Time=\"<!--Time-->\" DateTime=\"<!--DateTimeUTC-->\" SessionID=\"<!--SessionID-->\">"
		"<From><User LogonName=\"<!--FromAccount-->\" FriendlyName=\"<!--FromName-->\"/></From>"
		"<To><!--ToList--></To>"
		"<Text Style=\"<!--CSS-->\"><!--Message--></Text>"
		"</Message>"
	),
	_T(""),
	_T(""),
	_T(
		"<Join Date=\"<!--Date-->\" Time=\"<!--Time-->\" DateTime=\"<!--DateTimeUTC-->\" SessionID=\"<!--SessionID-->\">"
		"<User LogonName=\"<!--FromAccount-->\" FriendlyName=\"<!--FromName-->\"/>"
		"<Text Style=\"color:#008000; \"><!--FromName-->i<!--FromAccount-->j bɎQ܂B</Text>"
		"</Join>"
	),
	_T(
		"<Leave Date=\"<!--Date-->\" Time=\"<!--Time-->\" DateTime=\"<!--DateTimeUTC-->\" SessionID=\"<!--SessionID-->\">"
		"<User LogonName=\"<!--FromAccount-->\" FriendlyName=\"<!--FromName-->\"/>"
		"<Text Style=\"color:#800000; \"><!--FromName-->i<!--FromAccount-->j bސȂ܂B</Text>"
		"</Leave>"
	),
	_T(
		"<Invitation<!--Responce--> Date=\"<!--Date-->\" Time=\"<!--Time-->\" DateTime=\"<!--DateTimeUTC-->\" SessionID=\"<!--SessionID-->\">"
		"<From><User LogonName=\"<!--FromAccount-->\" FriendlyName=\"<!--FromName-->\"/></From>"
		"<File><!--FileName--></File>"
		"<Text Style=\"<!--CSS-->\">t@C\"<!--FileName-->\"̓]<!--Message-->܂</Text>"
		"</Invitation<!--Responce-->>"
	),
};

// 𕡐
LPTSTR DuplicateStr(LPCTSTR lpStr)
{
	LPTSTR newStr;
	int len;

	len = lstrlen(lpStr) + 1;
	newStr = new TCHAR[len];
	lstrcpy(newStr, lpStr);

	return newStr;
}

